% Examples from
%Sensitivity analysis methods
%in the biomedical sciences
% George Qian and Adam Mahdi

% probability of cancer
cancer=@(x)1-(1-(1-(1-x(:,1)).^x(:,2)).^x(:,3)).^(x(:,4).*x(:,5));
% values for 70 years old
atc={{'unif',{1e-6,3e-6},'k','mutation rate'},...
    {'unif',{6e3,2e4},'d','divisions per cell during lifetime'},...
    {'unif',{5,6},'k','rate limiting mutations'},...
    {'unif',{8,40},'n','stem cells per crypt'},...
    {'unif',{1e7,2e7},'m','crypts in colon'}};
    

%% cell dynamics of Johnston et al.

odefun=@(t,x,p)[(p(3)-p(1)-p(2))*x(1)-p(8)*x(1).^2./(1+p(9)*x(1));...
(p(6)-p(4)-p(5))*x(2)+p(2)*x(1)-p(10)*x(2).^2./(1+p(11)*x(2))+p(8)*x(1).^2./(1+p(9)*x(1)); ...
-p(7)*x(3)+p(5)*x(2)+p(10)*x(2).^2./(1+p(11)*x(2))];
xstart=[1;100;100];
tspan=linspace(0,100,200);
% 
atp={{'unif',{.1*.9,.1*1.1},'\alpha_1','rate of stem cell death'},...
    {'unif',{.3*.9,.3*1.1},'\alpha_2','rate of stem cell differentiation'},...
    {'unif',{.69*.9,.69*1.1},'\alpha_3','rate of stem cell proliferation'},...
    {'unif',{.1*.9,.1*1.1},'\beta_1','rate of semi-differentiated cell death'},...
    {'unif',{.3*.9,.3*1.1},'\beta_2','rate of semi-differentiated cell differentiation'},...
    {'unif',{.397*.9,.397*1.1},'\beta_3','rate of semi-differentiated cell proliferation'},...
    {'unif',{.139*.9,.139*1.1},'\gamma','rate of removal of fully differentiated cells'},...
    {'unif',{0.1*.9,.1*1.1},'k_0','feedback constant'},...
    {'unif',{0.1*.9,.1*1.1},'m_0','feedback constant'},...
    {'unif',{0.0003*.9,.0003*1.1},'k_1','feedback constant'},...
    {'unif',{0.0004*.9,.0004*1.1},'m_1','feedback constant'}};

n=4096;
x=autotrans(sobolpoints(n,length(atp)),atp);
ys=[];
for p=x'
[t,y]=ode45(@(t,z)odefun(t,z,p),tspan,xstart);
ys(end+1,:)=y(:,1)'; % influence on stem cells
end
